// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	. "gitlab.com/commonground/nlx/fsc-nlx/manager/ports/intunauthenticated/rest/api/models"
)

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// GetJSONWebKeySet request
	GetJSONWebKeySet(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)

	// GetHealth request
	GetHealth(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) GetJSONWebKeySet(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetJSONWebKeySetRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) GetHealth(ctx context.Context, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetHealthRequest(c.Server)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewGetJSONWebKeySetRequest generates requests for GetJSONWebKeySet
func NewGetJSONWebKeySetRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/.well-known/jwks.json")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewGetHealthRequest generates requests for GetHealth
func NewGetHealthRequest(server string) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/v1/health")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// GetJSONWebKeySetWithResponse request
	GetJSONWebKeySetWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetJSONWebKeySetResponse, error)

	// GetHealthWithResponse request
	GetHealthWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetHealthResponse, error)
}

type GetJSONWebKeySetResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *Jwks
}

// Status returns HTTPResponse.Status
func (r GetJSONWebKeySetResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetJSONWebKeySetResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type GetHealthResponse struct {
	Body         []byte
	HTTPResponse *http.Response
}

// Status returns HTTPResponse.Status
func (r GetHealthResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetHealthResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// GetJSONWebKeySetWithResponse request returning *GetJSONWebKeySetResponse
func (c *ClientWithResponses) GetJSONWebKeySetWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetJSONWebKeySetResponse, error) {
	rsp, err := c.GetJSONWebKeySet(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetJSONWebKeySetResponse(rsp)
}

// GetHealthWithResponse request returning *GetHealthResponse
func (c *ClientWithResponses) GetHealthWithResponse(ctx context.Context, reqEditors ...RequestEditorFn) (*GetHealthResponse, error) {
	rsp, err := c.GetHealth(ctx, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetHealthResponse(rsp)
}

// ParseGetJSONWebKeySetResponse parses an HTTP response from a GetJSONWebKeySetWithResponse call
func ParseGetJSONWebKeySetResponse(rsp *http.Response) (*GetJSONWebKeySetResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetJSONWebKeySetResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest Jwks
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	}

	return response, nil
}

// ParseGetHealthResponse parses an HTTP response from a GetHealthWithResponse call
func ParseGetHealthResponse(rsp *http.Response) (*GetHealthResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetHealthResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Return a JSON Web Key Set as defined in RFC 7517
	// (GET /.well-known/jwks.json)
	GetJSONWebKeySet(w http.ResponseWriter, r *http.Request)
	// health endpoint for the Internal Manager API
	// (GET /v1/health)
	GetHealth(w http.ResponseWriter, r *http.Request)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Return a JSON Web Key Set as defined in RFC 7517
// (GET /.well-known/jwks.json)
func (_ Unimplemented) GetJSONWebKeySet(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// health endpoint for the Internal Manager API
// (GET /v1/health)
func (_ Unimplemented) GetHealth(w http.ResponseWriter, r *http.Request) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// GetJSONWebKeySet operation middleware
func (siw *ServerInterfaceWrapper) GetJSONWebKeySet(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetJSONWebKeySet(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// GetHealth operation middleware
func (siw *ServerInterfaceWrapper) GetHealth(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetHealth(w, r)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/.well-known/jwks.json", wrapper.GetJSONWebKeySet)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/v1/health", wrapper.GetHealth)
	})

	return r
}

type GetJSONWebKeySetRequestObject struct {
}

type GetJSONWebKeySetResponseObject interface {
	VisitGetJSONWebKeySetResponse(w http.ResponseWriter) error
}

type GetJSONWebKeySet200JSONResponse Jwks

func (response GetJSONWebKeySet200JSONResponse) VisitGetJSONWebKeySetResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetHealthRequestObject struct {
}

type GetHealthResponseObject interface {
	VisitGetHealthResponse(w http.ResponseWriter) error
}

type GetHealth200Response struct {
}

func (response GetHealth200Response) VisitGetHealthResponse(w http.ResponseWriter) error {
	w.WriteHeader(200)
	return nil
}

type GetHealth503Response struct {
}

func (response GetHealth503Response) VisitGetHealthResponse(w http.ResponseWriter) error {
	w.WriteHeader(503)
	return nil
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Return a JSON Web Key Set as defined in RFC 7517
	// (GET /.well-known/jwks.json)
	GetJSONWebKeySet(ctx context.Context, request GetJSONWebKeySetRequestObject) (GetJSONWebKeySetResponseObject, error)
	// health endpoint for the Internal Manager API
	// (GET /v1/health)
	GetHealth(ctx context.Context, request GetHealthRequestObject) (GetHealthResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHTTPHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHTTPMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// GetJSONWebKeySet operation middleware
func (sh *strictHandler) GetJSONWebKeySet(w http.ResponseWriter, r *http.Request) {
	var request GetJSONWebKeySetRequestObject

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetJSONWebKeySet(ctx, request.(GetJSONWebKeySetRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetJSONWebKeySet")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetJSONWebKeySetResponseObject); ok {
		if err := validResponse.VisitGetJSONWebKeySetResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// GetHealth operation middleware
func (sh *strictHandler) GetHealth(w http.ResponseWriter, r *http.Request) {
	var request GetHealthRequestObject

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetHealth(ctx, request.(GetHealthRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetHealth")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetHealthResponseObject); ok {
		if err := validResponse.VisitGetHealthResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xZW2/buPL/KgPu/6EFHOXS2G29T2nqbt1r/nGC7EFoHNDS2GIjkVqScqIt+t0PhpRk",
	"+VIn+7AHOMA+tLFlXmbmN/Obi76zWOeFVqicZcPvzMYp5sJ/xPiinGUy/ogVfS2MLtA4if7H2Czpj6sK",
	"ZENmnZFqwX702AM9TdDGRhZOasWGLJwCH7GCB4i1NolUwmEEV6m0UAgjcnRoINbKCaksuBTXVsJcG3rI",
	"1SjL6NgYzkuzRCi0VC6CsQNpwWBh0KJymIAIh8yExcFpaTJAFetEqgXoOVf0k44dOghyr7YKEhn03O9e",
	"CdCjAxOcS4UJSMXVBGO/8iR6EfVp/WR0fgy39P+U9ELIUC1cGo6Sdv26z9eTK65m6G+Zl1kGVv6JtFbs",
	"0Bpir6stMJZz6QXwjzlhwBlXrQUjeKcN4IPIiwx7IIMaS5GV/vB6A9mKs4uD/skxZz1ojcFVLV5eWgcz",
	"hMEg/GAh02oRccV6bK5NLhwbslnlkPW28a/24l89Gf/qH/z/F/DPxcMnrykbDgY9lkvV/brhHT/aJ3r2",
	"DWNH/vLt/m7bY666Ygdd77CynHW8RVoQCoQxoqJVH24+hi02gjcVgSXKzNXqmQRNc9RqIdxLl9bGDOck",
	"Gi0o7UDmRVbR+e3WwuAcDaoYQeRaLWhX3gORuVSXixREUWQy9v5jG3kmZLtYKIhTrS2C0yCslQsFAnIU",
	"ioztdEfEGnFpoChNoS1aj2KCVhpMItZjWuHXORvefmf/Z3DOhuyXwxV/H9bkfdhl7h+9/WuNFZ3F094G",
	"z4tssTeiz7KFNtKl+VY4ywSVI48NsSiahSCVQ5VgQupyVVr0QPhFd1iF8KkRKi0mYFNdZgmgdCkackyD",
	"C2kdmjYWuBqffTkDzj5Mvn6BG5zBRC6UcKVBECqBkYpN5YVfyUveFA4yFVdonZhl0qaYwKyC2w83Z1PQ",
	"/jZRu6JLhVtxlIBznWXSSq0OuLpEK60TysEXkWNQgZPtOKt3k7tCLCweWFRWOrlEOJucj8c1KURcXVts",
	"+SLHfBac/OvF1fjrl7NPIf5QlTkb3rLLyUl/wHrscvLi1an/2z8+YT02qp+P6uej+vlF/fyifn7hn093",
	"EPgdVv/Whd0L+tcCTXD1x1DXzcpn9jlX5N/3qYxbsEnB1h2cJnMT5I0Ba1k24p6rrgfRBm9YOqk+vfCi",
	"9qAwcunpWxuwVZ6jMzIGTyUqFxVdVxN/xBVXY2c7aHXIhSRtNWloxuMhHeahWKqBofBmPbZEI+eVB8y7",
	"HuuxBJtP90YUFG09VqrV5wSNXGL38xvp7E6M6gdePo+ZTPbiNX67jVMdXE5DLlycgmgyTByi0G/gql7X",
	"86aWipw8xh5tq0ktsKEAi642VUusomFBrpLSpxYypNFZppeUrTzK1pky9pG64nqZdOKGq1K1yS8CuElR",
	"rS+yIExwnK2be5DIuSdux1VXtiYVTNDB5P3X609vvSMl0jqpYrdxQQTw7KtCrurkunK19vigeS4XqfMn",
	"0QVW5Nv6gAwlSAWpWGLnAM7uXMUZPCMrEcTPG/VmpfMqxlpZmXji88HCFf5RyqXIaLvIHBoliFkscZgn",
	"3VVWgtLKOm1Fz6EJMJKMq59TVE1OAI+Sk4elxQA+3Ewo6j7cjHo7Ud3yvrCBqw83o3bxexSUFi9ar/W7",
	"Q+RtE5fbX3teVQU+Rlc+QvXCiCKV8SplcTUXucyqjn41gfXAliQ+lVSXkzPOSGnORuecRdAiWsMYEhlX",
	"ezIZbCayRvL/QrrqyLrfFwIz1F5AxWyHSKGJvs18dUbZ6HwnnZUW9yJ3bR8Frs0IpffTUOOHNLAqKjjd",
	"tFlEYl5kugq+KFVC0YJwnyJBxJXoHNJ6LVFhzesUUolwgowfOL8OMrBNBcKVVn7NukWsXIT0sNMkD/14",
	"r0l+j/pHryGmOm0eRI5TIdXPeyoRFlAMayIybSDXBuHi4/j37jkWbi/fnfdPXh1Na4LeusRz8ka3JcB7",
	"bJsxu5uCRwXdiElHIk7bZmOt/vZeF5q2A9+xYQLPml7rlM4l4U4Hp6+mcHDAFZXqbY/X7HgOb0eXcDu+",
	"uo5+H7w+io5fvz6dbunZUgmpuPVjbbYGSwI/aNF4u+/cpLGOq86+Ojbg89m/aNGcMt19CFGRJJLUENma",
	"tXueTbhCEadgy5nFP0qKoq4wM2zk0Apb3gwrqlD+FgaXUpeWVtSweYdVK0HXjvRqBOZdBYpPkGtt9KwC",
	"7akqxLrt9FA/SwlcrResbYH0aBHz0Hd/0eUn788OjsGlZT4rjJ8EbBc5gqstD9naCM9EdBeJCBK5QOue",
	"N3q+HV1y1RkdUFG4LUYnYL5o1zDvagGRUXNTKFVEZjVYnaOTOVq4U/peURR1T51LtUATNtVu2oH0UTBh",
	"G0uufg7mU3qPHSTlfrHUV/x12E76g8eAg924re/cRI6rFXTdoY9/tgc6iLUxaAutaANXdVtORmwCLpEL",
	"6USWVZ7aa9NN/k7Mu6BslUJPgad8AjLXl592m//6cuzt8+L1q8E0KOhnINbPMSgDWF2aOMyp2sDoeF9X",
	"M2228whXm6mmTeoJtKd77y6MXsqEiputUV1I9Y/d1ZZDc21yr8Hlu3OguztSUHBdjD637kZrA0GD5+fu",
	"qQlmMpch+3G1NpxrEtYgOib46KLT16f9kLten/anP2HotVTy5KjeYuhgkEDRdE1htNOxzlpHFvEfpTQh",
	"h+00c2iwF0a6yu8O+vxKIL+/urqA30ZXYChRWUfnGWqrcYmbxMSVP5QqsqtPE6/+yavjV9M66k4H019D",
	"7eZRd1UTphbNclVY+u5EJsJREyosFGhWFm7sOzg+CfalD9P13NRWqlsR0w4zS5OxXdNKUlIaTKheo/Zi",
	"unuAuWNYsla/U4/pNDR6wPaUyvZAxLGf/PqRIKkCL/vHL6fPUucKOzw8vL+/jyS6eaTN4tDMY/pHKyL3",
	"4J73Vk1Jp9AwSLrE9UxSrfoZCxm1HW3Tcftucr66KdY59fRGlyqJFtJlYhZJfUgNQyJMYg/nNj6MtcHD",
	"xIi5O5jb+IC+HhwdRanLs1+UyPFAxDFae+D0HarnbHOsSM0y/W3Lg30jym/3d9sFwyY8dOAufNbmm1uv",
	"sfY3HvgQRNn/qqJZVZeIzdie2kHVbUF2vqYQ8KZJc9dj5VruacpTrt6tDV7uqc1uz2gKw3DzoN9/8bIz",
	"0YdQTcbo89kMd2RUH2R+rGBdE38uNYjN6P/2uAdHPTie/hp4xaAtM7fjpUlQW3YmaJyd/f/ZG86e+OZI",
	"7YUi10mZlXY/EvWivwmIVaKXeZFhTluNDVOcOQVL+JFy/MYgIZMzI4xE6yv1uXwgKsUHZwT8iUYf+DuS",
	"GrS69Gh0WTez17Oi5OtKozancuEpgXPSf9kg6NMznBydvjqYSReGFkaE9talQsFJfxDBuFGpviZMi/xw",
	"o5Ue7mWWgcKQRpy4Q65iqm2cBp1LV0cDqRVUmRudr7+Ia8zaaSD9hU/yke33R/RIqrnedp2x8tOwDK6V",
	"KF1KsRIT0p+FEgs0cDmaXMHZxZiAPReqmTyv5bPaZ6QKcpGXZ/Kuw98fsarnwE66DH9yrejee3YxDuNh",
	"G+Q8jo6iI3J/XaAShWRD9iI6il4QYwqXepI6jO4xyw58yUhkaKNvVvtwWaDvmdrZ9DhhQ/YbOpLwBmcf",
	"sZqgY8SUVNrawHknR0f+Db5WDpXf3xkTHjZHB/J9AjXbAMM/+W9f/iML2TLPhanYkF36OG2GJl0zrb1n",
	"hsYKfvvh8vgwRZG5dB/y78OK3ZD/JEQ6vknEGC7xPXn/6MXT95Wq3bmmbXgKqBL/vr7l5V3nBF8KFaD1",
	"7zmpNhuyBpvveVh7bbIfw9NTCpOlMFLMsqDo6ucgt38LzIYs07HIUm3Di5iuNteXn5rEV8tBMkx//CcA",
	"AP//uYiJCxkjAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
